/*
$Header: /home/CVSrepository/xconcordancer/xconcordancer.cc,v 1.2 2000/04/29 21:03:30 ralph Exp $
$Author: ralph $
$Locker:  $
$State: Exp $
$Log: xconcordancer.cc,v $
Revision 1.2  2000/04/29 21:03:30  ralph
Added a note about future additions or possibilities.  No code changes.

Revision 1.1.1.1  2000/04/29 20:49:00  ralph
initial import of Motif GUI concordancer into CVS

*
*
* NOTES:
* 1) 4/16/00 - Help window working, but pressing help button twice gives another help screen.
*   must figure out how to stop this when I get more important things done.
* 2) 4/22/00 - segfaulting upon return from pars after not finding file.  Stopped by stating file in concordanceCB function.
* 3) Starting with wrong number after first run.  Need to reset numbers for files between runs
* THINGS TO DO:
* 1) Read out to the operator the names of the output files at the end OK
* 2) Clear the input and output file boxes. OK
* Future possibilities:
* 3) Add windows to read the output files in read-only manner upon completion 
* of concordancing.
*/

//#define DEBUG
//#define DEBUGS
//#define DEBUGP

#include "xconcordancer.h"

//global variables -- used by parser:
unsigned int lineNum=1;   //line counter for doing number of lines to make up a page.
int StdPageLines=60;
unsigned int locNum=1;   //line/page/stanza number of document determined by CR/FF/n>.
unsigned int beginningLocNum=locNum; //beginning count of lines
long fileLoc=1;      //read location in file
long wordCount=0;    //number of words in file

enum CtType{PAGE, LINE, STANZA, COUNT}; //command line switch indicators
CtType countType=PAGE;

XtAppContext context;
XmStringCharSet char_set=XmSTRING_DEFAULT_CHARSET;

/*~~~~~ Widgets: ~~~~~*/
/* Major Widgets: */
Widget toplevel; 
/* BulletinBoard Widgets: */
Widget bb, bbHelp;

/* Pushbutton Widgets:*/
Widget buttonOK, buttonCancel, buttonConcordance, buttonClose,buttonHelp;
Widget  buttonBrowseInput, buttonBrowseOutput;
Widget buttonHelpShellClose;

/* Label Widgets: */
Widget labelInputfile, labelOutputfile, labelRadioInstructions, labelPageFFCt, labelPixmap;
Widget labelLineCt, labelStanzaCt, labelPageLnCt, labelNumLnsPg;
Widget labelBeginningPageCt, labelBeginningLineCt, labelProgress, labelWordCount;
Widget labelOutWordsFile, labelOutAbcFile;

/*Message Widgets*/
Widget messageInfileOpenError, messageInvalidNumber, messageInvalidPgLnNum, messageDone;

/* Textbox Widgets: */
Widget textInputfile, textOutputfile, textPgLns, textStartNum, textHelp, textProgress;
Widget textOutWordsFile, textOutAbcFile;

/* Radio Box Widget to hold toggle buttons */
Widget radioBox;

/* ToggleButtonWidgets */
Widget toggleFFPageCt, toggleLineCt, toggleStanzaCt, toggleLinePageCt;

/* Scale Widget to read out progress */
Widget scaleProgress;

/* Separator Widget(s) */
Widget separatorProgress, separatorOutput;

/* Shell Widgets(s) */
Widget shellHelp;

/* Pixmaps */
Pixmap pix;

/*~~~~~~forward declarations~~~~~~*/
//external functions in utility function file concutils.cc:
extern int ateof(istream &instream);
extern int ateof(FILE *fp);
extern char *lowerCaseString(char *stringToLc);
extern void getFilenameOnly(char *fname);
extern BOOLEAN isAlphaDiacritic(int c);
extern BOOLEAN isFlagError(BOOLEAN stanzaflag,BOOLEAN pageflag,BOOLEAN lineflag);
extern int isNum(char *string); //checks string to see if string is a valid decimal number


void initializeShellHelp(void);
void parse(char *fname,char countType,char *ofname);   //parse file into words
void saveConFile(char *origFn, char *conFn, char ctType,WordList &wl);   //save concordance file
void saveAlphabetFile(char *origFn, char *alphaFn,CharCtVector &ccv); //save alphabet count file

/*~~~~~~~~~~~~~~General usage functions~~~~~~~~~~~~*/

/* get information needed for pixmap label widget */
unsigned int get_depth(Widget w)
{
	Window r;
	int x, y;
	unsigned int wd,ht,bw,depth;

	//XtScreen(toplevel) was former setting:
	XGetGeometry(XtDisplay(w), RootWindowOfScreen(XtScreen(bb)), &r, &x, &y, &wd, &ht,&bw,&depth);
}


/*~~~~~~~~~~~~~~ Callback Functions ~~~~~~~~~~~~*/
/* Help button callback function */
void buttonHelpCB(Widget w, XtPointer client_data, XmPushButtonCallbackStruct *call_data)
{
	/*stub*/
	//puts("help button pushed");
	/* Put help widget on screen */
     initializeShellHelp(); //this works here rather than in main! Must be initialized each popup apparently###
     XtPopup(shellHelp,XtGrabNone); //this must be used with PopupShell### See Vol. IV, p. 303.
}

/* Help shell close button Callback Function */
void buttonHelpShellCloseCB(Widget w, XtPointer client_data, XmPushButtonCallbackStruct *call_data)
{
	/* Close the Help Shell */
	//XtUnrealizeWidget(shellHelp);
	XtPopdown(shellHelp); //this must be used with PopupShell### See Vol. IV, p. 302.
}

/* concordance it button callback function:  */
void buttonConcordanceCB(Widget w, XtPointer client_data, XmPushButtonCallbackStruct *call_data)
{
	char *infile, *outfile;
	char *linesPerPage, *startNum;
	struct stat statbfr;

	/* get the files from the file text boxes & check the names' validity 
	 * Note that you must use XtFree(stringname) to free the strings' memory 
	 * alloted by XmTextGetString()  !! */
	infile=XmTextGetString(textInputfile);
	outfile=XmTextGetString(textOutputfile);

	//get, check, & convert lines to consider a page:
	linesPerPage=XmTextGetString(textPgLns);
#ifdef DEBUG
	printf("In buttonConcordanceCB(); infile is %s, outfile is %s, linesPerPage is %s\n",infile,outfile,linesPerPage);
#endif DEBUG

	if(isNum(linesPerPage)){
			StdPageLines=atoi(linesPerPage);
			XtFree(linesPerPage);
	}
	else{
			XtFree(linesPerPage);
			XtManageChild(messageInvalidNumber);
			XtFree(infile);
			XtFree(outfile);
			return;
	}
#ifdef DEBUG
	printf("In buttonConcordanceCB(); after check for number in linesPerPage which is %d\n",StdPageLines);
#endif DEBUG

	//get, check and convert starting page/line number
	startNum=XmTextGetString(textStartNum);
	if(isNum(startNum)){
			beginningLocNum=atoi(startNum);
			XtFree(startNum);
	}
	else{
			XtFree(startNum);
			XtManageChild(messageInvalidPgLnNum);
			XtFree(infile);
			XtFree(outfile);
			return;
	}
#ifdef DEBUG
	printf("DEBUGGING: In buttonConcordanceCB() after check for startNum which is %d\n",beginningLocNum);
#endif DEBUG

	//make sure the infile exists
	if((stat(infile,&statbfr))==-1){
			XtFree(infile);
			XtFree(outfile);
			XtManageChild(messageInfileOpenError);
			return;
	}

	/* this switch calls the parsing function to do the work: */
	switch(countType){
	case PAGE:
#ifdef DEBUG
		puts("Words counted by page toggle pressed");
#endif
		parse(infile,'p',outfile); /* may be ables to change parse() to receive only the type of count to be done as arg */
#ifdef DEBUG
		cout << "DEBUGGING: In buttonConcordanceCB() after case PAGE call to parse()\n";
#endif
		break;
	case LINE:
#ifdef DEBUG
		puts("Words counted by line toggle pressed");
#endif
		parse(infile,'l',outfile);
		break;
	case STANZA:
#ifdef DEBUG
		puts("Words counted by stanza toggle pressed");
#endif
		parse(infile,'s',outfile);
		break;
	case COUNT: //added for paging via line counting
#ifdef DEBUG
		puts ("Words counted by num lines per page toggle pressed");
#endif
		parse(infile,'c',outfile);
		break;
	}

	XtFree(infile);
	XtFree(outfile);

	//reset globals to defaults after run:
	lineNum=1;   //line counter for doing number of lines to make up a page.
	StdPageLines=60;
	locNum=1;   //line/page/stanza number of document determined by CR/FF/n>.
	beginningLocNum=locNum; //beginning count of lines
	fileLoc=1;      //read location in file
	wordCount=0;    //number of words in file

#ifdef DEBUG
	printf("DEBUGGING: At end of buttonConcordanceCB()\n");
#endif DEBUG

	return;
}

/* Cancel button callback function: */
void buttonCancelCB(Widget w, XtPointer client_data, XmPushButtonCallbackStruct *call_data)
{
#ifdef DEBUG
	printf("Cancel button Pushed - exiting Program\n");//CHANGE THIS TO MESSAGE BOX
#endif
	exit(0);
}

void toggleCB(Widget w, XtPointer client_data,XmAnyCallbackStruct *call_data)
{
#ifdef DEBUG
	puts ("Toggle pressed, & type of counting chosen");
#endif

	switch((int)client_data){
	case 1:
		countType=PAGE;
		XtUnmanageChild(labelBeginningLineCt);
		XtManageChild(labelBeginningPageCt);
		XtManageChild(textStartNum);
		XtUnmanageChild(labelNumLnsPg);
		XtUnmanageChild(textPgLns); 
		break;
	case 2:
		countType=LINE;
		XtUnmanageChild(labelBeginningPageCt);
		XtManageChild(labelBeginningLineCt);
		XtManageChild(textStartNum);
		XtUnmanageChild(labelNumLnsPg);
		XtUnmanageChild(textPgLns); 
		break;
	case 3:
		countType=STANZA;
		XtUnmanageChild(labelNumLnsPg);
		XtUnmanageChild(textPgLns); 
		XtUnmanageChild(labelBeginningLineCt);
		XtUnmanageChild(labelBeginningPageCt);
		XtUnmanageChild(textStartNum);
		break;
	case 4:
		countType=COUNT;
		XtManageChild(labelBeginningPageCt);
		XtManageChild(textStartNum);
		XtManageChild(labelNumLnsPg);
		XtManageChild(textPgLns); 
		break;
	}
}

void messageDoneCB(Widget w, XtPointer client_data,XmAnyCallbackStruct *call_data)
{
	Arg al[3];
	int ac;

	//reset the progress scale & word-counter variable and textbox to 0
	XmScaleSetValue(scaleProgress,0);
	
	wordCount=0; //if used again, reset the word counter
	ac=0;
	XtSetArg(al[ac],XmNvalue,"0");ac++;  /* Reset initial value in box */ 
	XtSetValues(textProgress,al,ac);

	//blank the input and output filename textboxes:
	 ac=0;
	XtSetArg(al[ac],XmNvalue,"");ac++;
	XtSetValues(textInputfile, al, ac);

	ac=0;
	XtSetArg(al[ac],XmNvalue,"");ac++;
	XtSetValues(textOutputfile,al, ac);

	//blank the output .wds and .abc file textboxes:
	 ac=0;
	XtSetArg(al[ac],XmNvalue,"");ac++;
	XtSetValues(textOutWordsFile, al, ac);

	ac=0;
	XtSetArg(al[ac],XmNvalue,"");ac++;
	XtSetValues(textOutAbcFile,al, ac);

		
	XtUnmanageChild(w); //close the Error message box
}


void messageErrorCB(Widget w, XtPointer client_data,XmAnyCallbackStruct *call_data)
{
	XtUnmanageChild(w); //close the Error message box
}

/*~~~~~~~~~~~~~~ Initialization Functions ~~~~~~~~~~~~*/
void initializeLabels(void)
{
	Arg al[10];
	int ac;  /* argument count */
	int foreground, background;
	unsigned int depth;

	/* create the various labels needed */
	/* Input file textbox label: */
	ac=0;
	XtSetArg(al[ac],XmNlabelString,XmStringCreateLtoR("Enter Name [with path] of file to concordance:",char_set));ac++;
	XtSetArg(al[ac],XmNalignment,XmALIGNMENT_BEGINNING); ac++;
	XtSetArg(al[ac],XmNy,LABEL_INPUT_FILE_YLOC);ac++;
	XtSetArg(al[ac],XmNx,LABEL_INPUT_FILE_XLOC);ac++;
	labelInputfile=XmCreateLabel(bb,"labelInputfile",al,ac);
	XtManageChild(labelInputfile);

	/* Output file textbox label: */
	ac=0;
	XtSetArg(al[ac],XmNlabelString,XmStringCreateLtoR("[Optional] Enter name [with path] for output files:",char_set));ac++;
	XtSetArg(al[ac],XmNalignment,XmALIGNMENT_BEGINNING); ac++;
	XtSetArg(al[ac],XmNy,LABEL_OUTPUT_FILE_YLOC);ac++;
	XtSetArg(al[ac],XmNx,LABEL_OUTPUT_FILE_XLOC);ac++;
	labelOutputfile=XmCreateLabel(bb,"labelOutputfile",al,ac);
	XtManageChild(labelOutputfile);

	/* labelRadioInstructions,*/
	ac=0;
	XtSetArg(al[ac],XmNlabelString,XmStringCreateLtoR("Select word location type (Default is by FormFeed Paging):",char_set));ac++;
	XtSetArg(al[ac],XmNalignment,XmALIGNMENT_BEGINNING); ac++;
	XtSetArg(al[ac],XmNy,LABEL_RADIOBOX_INST_YLOC);ac++;
	XtSetArg(al[ac],XmNx,LABEL_RADIOBOX_INST_XLOC);ac++;
	labelRadioInstructions=XmCreateLabel(bb,"labelRadioInstructions",al,ac);
	XtManageChild(labelRadioInstructions);

	/* labelNumLnsPg */
	ac=0;
	XtSetArg(al[ac],XmNlabelString,XmStringCreateLtoR("Enter the number of lines to consider a page:",char_set));ac++;
	XtSetArg(al[ac],XmNalignment,XmALIGNMENT_BEGINNING); ac++;
	XtSetArg(al[ac],XmNy,LABEL_LNSPERPAGE_YLOC);ac++;
	XtSetArg(al[ac],XmNx,LABEL_LNSPERPAGE_XLOC);ac++;
	labelNumLnsPg=XmCreateLabel(bb,"labelNumLnsPg",al,ac);
	//	XtManageChild(labelNumLnsPg);

	/* labelBeginningPageCt */
	ac=0;
	XtSetArg(al[ac],XmNlabelString,XmStringCreateLtoR("[Optional] Enter first Page Number (Default=1):",char_set));ac++;
	XtSetArg(al[ac],XmNalignment,XmALIGNMENT_BEGINNING); ac++;
	XtSetArg(al[ac],XmNy,LABEL_STARTNUM_YLOC);ac++;
	XtSetArg(al[ac],XmNx,LABEL_STARTNUM_XLOC);ac++;
	labelBeginningPageCt=XmCreateLabel(bb,"labelBeginningPageCt",al,ac);
	XtManageChild(labelBeginningPageCt);

	/* labelBeginningLineCt */
	ac=0;
	XtSetArg(al[ac],XmNlabelString,XmStringCreateLtoR("[Optional] Enter first Line Number (Default=1):",char_set));ac++;
	XtSetArg(al[ac],XmNalignment,XmALIGNMENT_BEGINNING); ac++;
	XtSetArg(al[ac],XmNy,LABEL_STARTNUM_YLOC);ac++;
	XtSetArg(al[ac],XmNx,LABEL_STARTNUM_XLOC);ac++;
	labelBeginningLineCt=XmCreateLabel(bb,"labelBeginningLineCt",al,ac);
	//	XtManageChild(labelBeginningLineCt);

	/* labelWordCount  */
	ac=0;
	XtSetArg(al[ac],XmNlabelString,XmStringCreateLtoR("Words Concordanced:",char_set));ac++;
	XtSetArg(al[ac],XmNalignment,XmALIGNMENT_BEGINNING); ac++;
	XtSetArg(al[ac],XmNy,LABEL_WORDCOUNT_YLOC);ac++;
	XtSetArg(al[ac],XmNx,LABEL_WORDCOUNT_XLOC);ac++;
	labelWordCount=XmCreateLabel(bb,"labelWordCount",al,ac);
	XtManageChild(labelWordCount);
	
	/* labelOutWordsFile  */
	ac=0;
	XtSetArg(al[ac],XmNlabelString,XmStringCreateLtoR("Output .wds file:",char_set));ac++;
	XtSetArg(al[ac],XmNalignment,XmALIGNMENT_BEGINNING); ac++;
	XtSetArg(al[ac],XmNy,LABEL_OUTWORDSFILE_YLOC);ac++;
	XtSetArg(al[ac],XmNx,LABEL_OUTWORDSFILE_XLOC);ac++;
	labelOutWordsFile=XmCreateLabel(bb,"labelOutWordsFile",al,ac);
	XtManageChild(labelOutWordsFile);

	/* labelOutAbcFile  */
	ac=0;
	XtSetArg(al[ac],XmNlabelString,XmStringCreateLtoR("Output .abc file:",char_set));ac++;
	XtSetArg(al[ac],XmNalignment,XmALIGNMENT_BEGINNING); ac++;
	XtSetArg(al[ac],XmNy,LABEL_OUTABCFILE_YLOC);ac++;
	XtSetArg(al[ac],XmNx,LABEL_OUTABCFILE_XLOC);ac++;
	labelOutAbcFile=XmCreateLabel(bb,"labelOutAbcFile",al,ac);
	XtManageChild(labelOutAbcFile);

	/* labelPixmap */
	ac=0;
	XtSetArg(al[ac],XmNy,LABEL_PIXMAP_YLOC);ac++;
	XtSetArg(al[ac],XmNx,LABEL_PIXMAP_XLOC);ac++;
	labelPixmap=XmCreateLabel(bb,"labelPixmap",al,ac);
	XtManageChild(labelPixmap);
	/* get the base colors of the label */
	ac=0;
	XtSetArg(al[ac],XmNforeground,&foreground);ac++;
	XtSetArg(al[ac],XmNbackground,&background);ac++;
	XtGetValues(labelPixmap,al, ac);
#ifdef DEBUGP
	cout << "DEBUG Pixmap - foreground = "<< foreground << endl;
	cout << "DEBUG Pixmap - background = "<< background << endl;
#endif
	/* get the depth of the toplevel widget so the pixmap can be created */
	depth=get_depth(bb);
#ifdef DEBUGP
	cout << "DEBUG Pixmap - depth = "<< depth << endl;
#endif
	/*get the pixmap */
	pix=XmGetPixmap(XtScreen(bb),"/home/ralph/RandRbig2.xpm",foreground,background);
	/*set labelPixmap's resources */
	ac=0;
	XtSetArg(al[ac],XmNlabelType,XmPIXMAP);ac++;
	XtSetArg(al[ac],XmNlabelPixmap,pix);ac++;
	XtSetValues(labelPixmap,al, ac);
}

/* Set up the Textboxes */
void initializeTextboxes(void)
{
	Arg al[10]; /*argument array */
	int ac;  /* argument count */

	/* create the text widgets for entry of filenames/paths */
	/* textInputfile */
	ac=0;
	XtSetArg(al[ac],XmNy,TEXTBOX_INPUT_FILE_YLOC);ac++;
	XtSetArg(al[ac],XmNx,TEXTBOX_INPUT_FILE_XLOC);ac++;
	XtSetArg(al[ac],XmNmaxLength,156);ac++;
	XtSetArg(al[ac],XmNcolumns,55);ac++;
	textInputfile=XmCreateText(bb,"textInputfile",al,ac);
	XtManageChild(textInputfile); 

	/* textOutputfile */
	ac=0;
	XtSetArg(al[ac],XmNy,TEXTBOX_OUTPUT_FILE_YLOC);ac++;
	XtSetArg(al[ac],XmNx,TEXTBOX_OUTPUT_FILE_XLOC);ac++;
	XtSetArg(al[ac],XmNmaxLength,156);ac++;
	XtSetArg(al[ac],XmNcolumns,55);ac++;
	textOutputfile=XmCreateText(bb,"textOutputfile",al,ac);
	XtManageChild(textOutputfile); 

	/* textPgLns */
	ac=0;
	XtSetArg(al[ac],XmNy,TEXTBOX_LNSPERPAGE_YLOC);ac++;  /*Y location on window */
	XtSetArg(al[ac],XmNx,TEXTBOX_LNSPERPAGE_XLOC);ac++;  /* X location on window */
	XtSetArg(al[ac],XmNvalue,"60");ac++;  /* Initial value in box */ 
	XtSetArg(al[ac],XmNmaxLength,5);ac++;  /* Max length of string permitted in box */
	XtSetArg(al[ac],XmNcolumns,4);ac++;  /* Number of columns in box on screen */
	textPgLns=XmCreateText(bb,"textPgLns",al,ac);

	/* textStartNum */
	ac=0;
	XtSetArg(al[ac],XmNy,TEXTBOX_STARTNUM_YLOC);ac++;
	XtSetArg(al[ac],XmNx,TEXTBOX_STARTNUM_XLOC);ac++;
	XtSetArg(al[ac],XmNvalue,"1");ac++;
	XtSetArg(al[ac],XmNmaxLength,6);ac++;
	XtSetArg(al[ac],XmNcolumns,4);ac++;
	textStartNum =XmCreateText(bb,"textStartNum ",al,ac);
	XtManageChild(textStartNum ); 

	//progress textbox
	ac=0;
	XtSetArg(al[ac],XmNy,TEXTBOX_PROGRESS_YLOC);ac++;  /*Y location on window */
	XtSetArg(al[ac],XmNx,TEXTBOX_PROGRESS_XLOC);ac++;  /* X location on window */
	XtSetArg(al[ac],XmNeditable,False);ac++;
	XtSetArg(al[ac],XmNcursorPositionVisible,False);ac++;
	XtSetArg(al[ac],XmNvalue,"0");ac++;  /* Initial value in box */ 
	XtSetArg(al[ac],XmNmaxLength,10);ac++;  /* Max length of string permitted in box */
	XtSetArg(al[ac],XmNcolumns,10);ac++;  /* Number of columns in box on screen */
	textProgress=XmCreateText(bb,"textProgress",al,ac);
	XtManageChild(textProgress); 

	// textOutWordsFile
	ac=0;
	XtSetArg(al[ac],XmNy,TEXTBOX_OUTWORDSFILE_YLOC);ac++;  /*Y location on window */
	XtSetArg(al[ac],XmNx,TEXTBOX_OUTWORDSFILE_XLOC);ac++;  /* X location on window */
	XtSetArg(al[ac],XmNeditable,False);ac++;
	XtSetArg(al[ac],XmNcursorPositionVisible,False);ac++;
	XtSetArg(al[ac],XmNmaxLength,156);ac++;  /* Max length of string permitted in box */
	XtSetArg(al[ac],XmNcolumns,25);ac++;  /* Number of columns in box on screen */
	textOutWordsFile=XmCreateText(bb,"textOutWordsFile",al,ac);
	XtManageChild(textOutWordsFile); 

	// textOutAbcFile
	ac=0;
	XtSetArg(al[ac],XmNy,TEXTBOX_OUTABCFILE_YLOC);ac++;  /*Y location on window */
	XtSetArg(al[ac],XmNx,TEXTBOX_OUTABCFILE_XLOC);ac++;  /* X location on window */
	XtSetArg(al[ac],XmNeditable,False);ac++;
	XtSetArg(al[ac],XmNcursorPositionVisible,False);ac++;
	XtSetArg(al[ac],XmNmaxLength,156);ac++;  /* Max length of string permitted in box */
	XtSetArg(al[ac],XmNcolumns,25);ac++;  /* Number of columns in box on screen */
	textOutAbcFile=XmCreateText(bb,"textOutAbcFile",al,ac);
	XtManageChild(textOutAbcFile); 
}

/* set up the radio box and its toggle buttons */
void initializeToggles(void)
{
	Arg al[10]; /*argument array */
	int ac;  /* argument count */

	/* create the radio box to hold the toggle buttons: */
	ac=0;
	XtSetArg(al[ac],XmNy,RADIOBOX_YLOC);ac++;
	XtSetArg(al[ac],XmNx,RADIOBOX_XLOC);ac++;
	radioBox=XmCreateRadioBox(bb,"radioBox",al,ac);
	XtManageChild(radioBox);

	/* create the toggle buttons: */
	/* toggleFFPageCt */
	ac=0;
 	XtSetArg(al[ac],XmNlabelString,XmStringCreateLtoR("Locate words by page using Formfeeds (default)",char_set));ac++;
	XtSetArg(al[ac],XmNalignment,XmALIGNMENT_BEGINNING); ac++;
	XtSetArg(al[ac],XmNset,True);ac++; /* Set this button on */
	toggleFFPageCt=XmCreateToggleButton(radioBox,"toggleFFPageCt",al,ac);
	XtManageChild(toggleFFPageCt);
	XtAddCallback(toggleFFPageCt,XmNvalueChangedCallback,toggleCB,(XtPointer)1);

	/* toggleLineCt  */
	ac=0;
 	XtSetArg(al[ac],XmNlabelString,XmStringCreateLtoR("Locate words by Line",char_set));ac++;
	XtSetArg(al[ac],XmNalignment,XmALIGNMENT_BEGINNING); ac++;
	toggleLineCt=XmCreateToggleButton(radioBox,"toggleLineCt",al,ac);
	XtManageChild(toggleLineCt);
	XtAddCallback(toggleLineCt,XmNvalueChangedCallback,toggleCB,(XtPointer)2);

	/* toggleStanzaCt */ 
	ac=0;
 	XtSetArg(al[ac],XmNlabelString,XmStringCreateLtoR("Locate words by Stanza Number \"n>\"",char_set));ac++;
	XtSetArg(al[ac],XmNalignment,XmALIGNMENT_BEGINNING); ac++;
	toggleStanzaCt=XmCreateToggleButton(radioBox,"toggleStanzaCt",al,ac);
	XtManageChild(toggleStanzaCt);
	XtAddCallback(toggleStanzaCt,XmNvalueChangedCallback,toggleCB,(XtPointer)3);

	/* toggleLinePageCt */
	ac=0;
 	XtSetArg(al[ac],XmNlabelString,XmStringCreateLtoR("Locate words via paging by Lines per Page",char_set));ac++;
	XtSetArg(al[ac],XmNalignment,XmALIGNMENT_BEGINNING); ac++;
	toggleLinePageCt=XmCreateToggleButton(radioBox,"toggleLinePageCt",al,ac);
	XtManageChild(toggleLinePageCt);
	XtAddCallback(toggleLinePageCt,XmNvalueChangedCallback,toggleCB,(XtPointer)4);
}

void	initializePushbuttons(void)
{
	Arg al[10]; /*argument array */
	int ac;  /* argument count */

	/* button help */
	ac=0;
	XtSetArg(al[ac],XmNy,BUTTON_HELP_YLOC);ac++;
	XtSetArg(al[ac],XmNx,BUTTON_HELP_XLOC);ac++;
	XtSetArg(al[ac],XmNlabelString,XmStringCreateLtoR(" Help ",char_set));ac++;
	buttonHelp=XmCreatePushButton(bb,"buttonHelp",al,ac);
	XtManageChild(buttonHelp);
	XtAddCallback(buttonHelp,XmNactivateCallback,buttonHelpCB,NULL);

	/* buttonConcordance */
	ac=0;
	XtSetArg(al[ac],XmNy,BUTTON_MAKEC_YLOC);ac++;
	XtSetArg(al[ac],XmNx,BUTTON_MAKEC_XLOC);ac++;
	XtSetArg(al[ac],XmNlabelString,XmStringCreateLtoR(" Make Concordance ",char_set));ac++;
	buttonConcordance=XmCreatePushButton(bb,"buttonConcordance",al,ac);
	XtManageChild(buttonConcordance);
	XtAddCallback(buttonConcordance,XmNactivateCallback,buttonConcordanceCB,NULL);

	/* buttonCancel */
	ac=0;
	XtSetArg(al[ac],XmNy,BUTTON_CANCEL_YLOC);ac++;
	XtSetArg(al[ac],XmNx,BUTTON_CANCEL_XLOC);ac++;
	XtSetArg(al[ac],XmNlabelString,XmStringCreateLtoR(" Cancel/Quit ",char_set));ac++;
	buttonCancel=XmCreatePushButton(bb,"buttonCancel",al,ac);
	XtManageChild(buttonCancel);
	XtAddCallback(buttonCancel,XmNactivateCallback,buttonCancelCB,NULL);
}

void initializeProgressScale(void)
{
	Arg al[10]; /*argument array */
	int ac;  /* argument count */

	/* scaleProgress  - scale to show progress of concordancing*/
	ac=0;
	XtSetArg(al[ac],XmNy,SCALE_YLOC);ac++;
	XtSetArg(al[ac],XmNx,SCALE_XLOC);ac++;
 	XtSetArg(al[ac],XmNtitleString,XmStringCreateLtoR("Concordeancing Progress - % completed.",char_set));ac++;
	XtSetArg(al[ac],XmNorientation,XmHORIZONTAL);ac++;
	XtSetArg(al[ac],XmNwidth,340);ac++;
	XtSetArg(al[ac],XmNshowValue,True);ac++;
	//	XtSetArg(al[ac],XmNsensitive,False);ac++;
	XtSetArg(al[ac],XmNprocessingDirection,XmMAX_ON_RIGHT);ac++;
	scaleProgress=XmCreateScale(bb,"scaleProgress",al,ac);
	XtManageChild(scaleProgress);
}

void initializeSeparators(void)
{
	Arg al[10]; /*argument array */
	int ac;  /* argument count */

	/* separatorProgress */
	ac=0;
	XtSetArg(al[ac],XmNy,SEPARATOR_PROGRESS_YLOC);ac++;
	//	XtSetArg(al[ac],XmNseparatorType,XmSINGLE_LINE);ac++;
	XtSetArg(al[ac],XmNseparatorType,XmDOUBLE_LINE);ac++;
	XtSetArg(al[ac],XmNwidth,SEPARATOR_LENGTH);ac++;
	separatorProgress=XmCreateSeparator(bb,"separatorProgress",al,ac);
	XtManageChild(separatorProgress);

	/* separatorOutput */
	ac=0;
	XtSetArg(al[ac],XmNy,SEPARATOR_OUTPUT_YLOC);ac++;
	XtSetArg(al[ac],XmNseparatorType,XmDOUBLE_LINE);ac++;
	XtSetArg(al[ac],XmNwidth,SEPARATOR_LENGTH);ac++;
	separatorOutput=XmCreateSeparator(bb,"separatorOutput",al,ac);
	XtManageChild(separatorOutput);
}

/* This creates the help shell and Widgets to go on it */
void initializeShellHelp(void)
{
	Arg al[10];
	int ac;

	ac=0;
	XtSetArg(al[ac], XmNwidth, HELPSHELL_WIDTH);ac++;
	XtSetArg(al[ac], XmNheight, HELPSHELL_HEIGHT);ac++;
	//	shellHelp=XtAppCreateShell("Help","shellHelp", applicationShellWidgetClass,XtDisplay(toplevel),al, ac);
	shellHelp=XtCreatePopupShell("Help",transientShellWidgetClass,toplevel,al, ac);

	/* Bulletin Board Widget to hold help close pushbutton widget and text widget */
	ac=0;
	bbHelp=XmCreateBulletinBoard(shellHelp,"bbHelp",al, ac);
	XtManageChild(bbHelp);

	/* Pushbutton to close the window when opened */
	ac=0;
	XtSetArg(al[ac],XmNy,10); ac++;
	XtSetArg(al[ac],XmNx,130); ac++;
	XtSetArg(al[ac],XmNlabelString,XmStringCreateLtoR(" Close ",char_set));ac++;
	buttonHelpShellClose=XmCreatePushButton(bbHelp,"buttonHelpShellClose",al,ac);
	XtManageChild(buttonHelpShellClose);
	XtAddCallback(buttonHelpShellClose,XmNactivateCallback,buttonHelpShellCloseCB,NULL);

	/* Create textbox to hold helpful information */
	ac=0;
	XtSetArg(al[ac],XmNy,50);ac++;
	//	XtSetArg(al[ac],XmNx,);ac++;
	XtSetArg(al[ac],XmNeditMode, XmMULTI_LINE_EDIT);ac++;
	XtSetArg(al[ac],XmNcolumns,41); ac++;
	XtSetArg(al[ac],XmNeditable,False); ac++;
	//XtSetArg(al[ac],XmNresizeWidth,True);ac++;
	//XtSetArg(al[ac],XmNresizeHeight,True);ac++;
	XtSetArg(al[ac],XmNheight,HELPSHELL_HEIGHT-60);ac++;
	XtSetArg(al[ac],XmNvalue,HELP_INFO);ac++;
	XtSetArg(al[ac],XmNscrollVertical,True);ac++;
	XtSetArg(al[ac],XmNscrollHorizontal,False);ac++;
	textHelp=XmCreateScrolledText(bbHelp,"textHelp",al,ac);
	XtManageChild(textHelp); 

	XtRealizeWidget(shellHelp);  //this must be used with PopupShell###
}


/*NOTE: I could possibly get by witn one of thiese boxes possibly using a function to set the string. and a
 * set of strings fiwh error messages.
 */
void initializeMessageBoxes(void)
{
	Arg al[10]; /*argument array */
	int ac;  /* argument count */

	//Error in locating/opening Input file:
	ac=0;
	XtSetArg(al[ac],XmNmessageString,XmStringCreateLtoR("ERROR: Couldn't open Input File. Please redo with correct filepath.",char_set));ac++;
	messageInfileOpenError=XmCreateErrorDialog(toplevel,"InfileOpenError",al,ac);
	XtAddCallback(messageInfileOpenError,XmNokCallback,messageErrorCB,NULL);
	XtUnmanageChild(XmMessageBoxGetChild(messageInfileOpenError,XmDIALOG_HELP_BUTTON));
	XtUnmanageChild(XmMessageBoxGetChild(messageInfileOpenError,XmDIALOG_CANCEL_BUTTON));

	//error message box for bad number in num lines to consider a page
	ac=0;
	XtSetArg(al[ac],XmNmessageString,XmStringCreateLtoR("ERROR: Invalid number in Lines per Page. Please enter a valid number.",char_set));ac++;
	messageInvalidNumber=XmCreateErrorDialog(toplevel,"InvalidNumber",al,ac);
	XtAddCallback(messageInvalidNumber,XmNokCallback,messageErrorCB,NULL);
	XtUnmanageChild(XmMessageBoxGetChild(messageInvalidNumber,XmDIALOG_HELP_BUTTON));
	XtUnmanageChild(XmMessageBoxGetChild(messageInvalidNumber,XmDIALOG_CANCEL_BUTTON));

	//error message box for bad number in beginning page/line number
	ac=0;
	XtSetArg(al[ac],XmNmessageString,XmStringCreateLtoR("ERROR: Invalid number in Start Lines or Page. Please enter a valid number.",char_set));ac++;
	messageInvalidPgLnNum=XmCreateErrorDialog(toplevel,"InvalidStartNum",al,ac);
	XtAddCallback(messageInvalidPgLnNum,XmNokCallback,messageErrorCB,NULL);
	XtUnmanageChild(XmMessageBoxGetChild(messageInvalidPgLnNum,XmDIALOG_HELP_BUTTON));
	XtUnmanageChild(XmMessageBoxGetChild(messageInvalidPgLnNum,XmDIALOG_CANCEL_BUTTON));

	//message box to indicate to operator that concordancing is done
	ac=0;
	XtSetArg(al[ac],XmNmessageString,XmStringCreateLtoR("CONCORDANCING IS COMPLETED.\n\nPress OK to reset Xconcordancer for another run.\nNOTE: that changes to Lines per page & Start number\nmust be reset manually.",char_set));ac++;
	messageDone=XmCreateInformationDialog(toplevel,"ConcordancingCompleted",al,ac);
	XtAddCallback(messageDone,XmNokCallback,messageDoneCB,NULL);
	XtUnmanageChild(XmMessageBoxGetChild(messageDone,XmDIALOG_HELP_BUTTON));
	XtUnmanageChild(XmMessageBoxGetChild(messageDone,XmDIALOG_CANCEL_BUTTON));
}



/* Main Function */
void main (int argc, char** argv)
{
	Arg al[10]; /*argument array */
	int ac;  /* argument count */

	/*create the top level shell */
	toplevel=XtAppInitialize(&context,"",NULL,0,&argc,argv,NULL, NULL, 0);
	/* size the toplevel to start with */
	ac = 0;
	XtSetArg(al[ac],XmNheight,TOPLEVEL_HEIGHT);ac++;
	XtSetArg(al[ac],XmNwidth,TOPLEVEL_WIDTH);ac++;
	XtSetValues(toplevel,al, ac);

	/* create the bulletin board to hold everything else */
	ac=0;
	bb=XmCreateBulletinBoard(toplevel,"bb",al,ac);
	XtManageChild(bb);

	initializeLabels();
	initializeTextboxes();
	initializeToggles();
	initializePushbuttons();
	initializeProgressScale();
	initializeSeparators();
	initializeMessageBoxes();

	/*run the app*/
	XtRealizeWidget(toplevel);
	XtAppMainLoop(context);
}


/*4/16/00 From here down in the file was transported from command line concordancer.
*It needs to be reworked.
* In concordancer, fname and ofname both were char arrays for which memory had been
*allocated by 'new', and the mem was deleted in main() at the end of the operation.
*/
//parser of words on line numbers, pages, stanzas.
void parse(char *fname,char countType,char *ofname)
{
   FILE *fp; //read-in file, char file, concordance file
	 int filedesc;
   char *filenameBfr;
   char *conFn;      //filename of the concordance words file
   char *alphaFn; //filename of the concordance alphabet characters used file
   char *cext=".wds";   //extension of the word list file
   char *aext=".abc";   //extension of the alphabet file
   int fnlen;  //length of the name of the output file with extensions
   off_t endloc;
 unsigned long int totalCt=0, progressDivider=0; //determined to be approximately 1 % of file size normally
  int percentProgress=0; //percent of progress in reading file, total count of bytes read for progress indication only
   CharCtVector ccv; //character counter
   WordList wl;   //the concordance: the linked list of words and information on their locations
	 Arg al[10];
	 int ac;
	 char numbfr[20];

#ifdef DEBUG
	 cout << "DEBUGGING INFORMATION: in parse Fn.: fname is "<<fname<<'\n';
	 cout << "DEBUGGING INFORMATION: in parse Fn.: ofname is "<<ofname<<'\n';
#endif

	 //set up to determine progress of concordancing find file size:
	 filedesc=open(fname,O_RDONLY);
	 endloc=lseek(filedesc,0,SEEK_END);
	 close(filedesc);
#ifdef DEBUGS
	 cout << "DEBUGS: In Parse() This is loc at end of infile " << fname << ": " << endloc << endl;
#endif
	 progressDivider=(endloc/100) +1;  //Get an approximate 1/100th of the file's size
#ifdef DEBUGS
	 cout << "DEBUGS: In Parse() Progress setup: progressDivider is " << progressDivider << ": endloc is: " << endloc << endl;
#endif


   //open file to be concordanced for read
   if((fp=fopen(fname,"rb"))==0){
		 //but if it doesn't open:
#ifdef DEBUG
	 cout << "DEBUGGING INFORMATION: in parse Fn.: infile didn't open-calling for error message box\n";
#endif
		 return;
   }

#ifdef DEBUG
	 cout << "DEBUGGING INFORMATION: in parse Fn.:  "<<fname<<" opened OK\n";
#endif

	 //Set up filenames for output .wds & .abc results files:
   if (strcmp(ofname,"")==0){   //if operator hasn't provided an output file name
		 filenameBfr=new char[(fnlen=strlen(fname)+EXTENSIONLEN)];
		 assert(filenameBfr!=0);
		 strcpy(filenameBfr,fname);  //use the filename of file to be concordanced
   }
   else {   //if operator has indicated the name of the output files:
		 filenameBfr=new char[(fnlen=strlen(ofname)+EXTENSIONLEN)];
		 assert(filenameBfr!=0);
		 strcpy(filenameBfr,ofname); //otherwise use provided output file name
   }

#ifdef DEBUG
	 cout << "DEBUGGING INFORMATION: in parse Fn.: after outputfilename setup\n";
	 cout << "DEBUGGING INFORMATION: in parse Fn.: ofname is "<<filenameBfr<<'\n';
#endif
	 
   getFilenameOnly(filenameBfr); //get a filename only for later storage

#ifdef DEBUG
	 cout << "DEBUGGING INFORMATION: in parse Fn.: filenameBfr is "<<filenameBfr<<'\n';
#endif

   conFn=new char[fnlen+EXTENSIONLEN];  //prepare the concordance .wds filename
   assert(conFn!=0); //POSSIBLY CHANGE THIS FOR MOTIF TO ERROR MESSAGE BOX & RETURN TO LET OP REDO?
   strcpy(conFn,filenameBfr);
   strcat(conFn,cext);

#ifdef DEBUG
	 cout << "DEBUGGING INFORMATION: in parse Fn.: concordance filename is "<<conFn<<'\n';
#endif
	 
   alphaFn=new char[fnlen+EXTENSIONLEN];   //prepare the alphabet character use filename
   assert(alphaFn!=0); //CHANGE THIS FOR MOTIF TO ERROR MESSAGE BOX & RETURN TO LET OP REDO?
   strcpy(alphaFn,filenameBfr);
   strcat(alphaFn,aext);

#ifdef DEBUG
	 cout << "DEBUGGING INFORMATION: in parse Fn.: alphabet filename is "<<alphaFn<<'\n';
#endif
	 
   delete [] filenameBfr;
   //End of setting up output filenames.
	 
   //data parser section--parse the data from the input file--IT WORKS DON'T MESS WITH IT!:
   char wordBfr[MAXBFRSZ];    //buffer to hold word
   int wordFlag=0;   //indicator of word in wordBfr
   int wordNdx=0;    //index into wordBfr
   int isNum=0;   //indicator that information in buffer is a number
   int isWord=0;  //indicator that information in buffer is a word
   size_t charsRead; //number of characters actually read from the file.
   unsigned char inbuffer[FILESEGMENT];  //holding buffer for reads

	 //set the starting location number:
   if(beginningLocNum>locNum)locNum=beginningLocNum;

   while (!ateof(fp)) {
      charsRead=fread(inbuffer,sizeof(char),sizeof(inbuffer),fp);
      assert(charsRead>0); //POSSIBLY CHANGE THIS FOR MOTIF TO ERROR MESSAGE BOX & RETURN TO LET OP REDO

      for (unsigned int n=0;n<FILESEGMENT&&n<charsRead&&char(inbuffer[n])!=EOF;n++) {
		ccv.incChar(inbuffer[n]);

		// show Progress: using scale and textbox showing number of words concordanced:
		totalCt++;
		if(totalCt%progressDivider==0){
				XmScaleSetValue(scaleProgress,percentProgress++);
				sprintf(numbfr,"%lu",(unsigned long)wordCount);
#ifdef DEBUGS
				cout << "(words counted) numbfr is " << numbfr << endl;
#endif
				ac=0;
				XtSetArg(al[ac],XmNvalue,numbfr);ac++;  /* Initial value in box */ 
				XtSetValues(textProgress,al,ac);
#ifdef DEBUGS
				cout << "DOING PROGRESS. totalCt is " << totalCt << ".   PROGRESS IS: " << percentProgress << endl;
#endif
		 }

         if (isAlphaDiacritic(inbuffer[n])||isdigit(inbuffer[n])){ //put inbuffer[n] characters and digits into initial buffer
            if (!wordFlag)wordFlag=1;   //as a word
            wordBfr[wordNdx++]=inbuffer[n];
            if (isdigit(inbuffer[n])&&!isWord)isNum=YES; //if inbuffer[n] character is a digit and there is no indication that there is a word
            else if (!isWord){
			 isWord=YES;  //if a digit has a letter included, inbuffer[n] change to word, otherwise it is a word
			 isNum=NO;    //added along with &&(inbuffer[n]!='>'&&!isWord) below
            }
         }
         else if (wordFlag&&!(inbuffer[n]=='>'&&isNum)){ //inbuffer[n]character is whitespace and there's a word in bfr
			 wordBfr[wordNdx]='\0';  //NULL end the word in wordBfr
			 wl.addWord(wordBfr,locNum);  //add the word to the concordance with its location or add the location to a word already there
			 fileLoc=ftell(fp); //note location in file
			 wordCount++;
			 wordNdx=isWord=wordFlag=isNum=0;
         }

         //increment the location in the file according to operator indication of what type of location to indicate:
				 //line-counting:
         if (inbuffer[n] == LF && countType == 'l') //if whitespace is Linefeed & we're counting lines...
					 locNum++; //increment locnum as line number on carriage return

				 //page counting using a certain number of lines (default = 60):
         else if ((inbuffer[n] == LF || inbuffer[n] == FF) && countType == 'c') {//if whitespace is Linefeed & we're counting lines for pages...
		     lineNum++;
				 //if we run across a form feed, increment the locNum and reset the linenum to a completed page
		     if (inbuffer[n] == FF){
					 unsigned int leftover;
					 locNum++;
					 leftover=lineNum%StdPageLines;
					 lineNum=lineNum-leftover;
				 }
			 else if(lineNum%StdPageLines==0)
				 locNum++; //increment locnum as line number on carriage return
		}
				 //page counting using FormFeeds:
         else if (inbuffer[n] == FF && countType == 'p') //if whitespace if a formfeed & we're counting pages...
            locNum++; //increment locnum as page number on formfeed

				 //stanza counting:
         else if (inbuffer[n] == '>' && countType == 's' && isNum){   //set stanza to stanza number
            wordBfr[wordNdx]='\0';  //end the string
            locNum=atoi(wordBfr);   //put the number into location number
            wordNdx=isWord=wordFlag=isNum=0; //start with new word
         }
      }
   }
   fclose(fp); //close the input file to be concordanced.

   saveConFile(fname,conFn,countType,wl); //save the list of words, usage amounts, and locations.
   saveAlphabetFile(fname,alphaFn,ccv);   //save the alphabet character usage listing.

	 //show the output file names:
	 ac=0;
	XtSetArg(al[ac],XmNvalue,conFn);ac++;
	XtSetValues(textOutWordsFile, al, ac);
	ac=0;
	XtSetArg(al[ac],XmNvalue,alphaFn);ac++;
	XtSetValues(textOutAbcFile,al, ac);

    delete [] conFn;
    delete [] alphaFn;

#ifdef DEBUG
		cout << "DEBUGGING: At very end of parse() function\n";
#endif

		//if progress scale isn't at 100%, set it there:
		XmScaleSetValue(scaleProgress,100);

		//ring the 'bell'
		XBell(XtDisplay(messageDone),100);

		XtManageChild(messageDone);
}



void saveConFile(char *origFn, char *conFn, char ctType,WordList &wl)
{
   ofstream confile(conFn);
   assert(confile!=0); //POSSIBLY CHANGE THIS FOR MOTIF TO ERROR MESSAGE BOX & RETURN TO LET OP REDO

   if(ctType=='s')      confile << "Initial stanza of file was stanza " << beginningLocNum << "\n";
   else if(ctType=='p' || ctType=='c') confile << "Initial page of file was page " << beginningLocNum << "\n";
   else if(ctType=='l') confile << "Initial line of file was line " << beginningLocNum << "\n";

   if(ctType=='s')        confile << "Last stanza of file was stanza " << locNum << "\n\n";
   else if(ctType=='p' || ctType=='c')   confile << "Last page of file was page " << locNum << "\n\n";
   else if(ctType=='l')   confile << "Last line of file was line " << locNum << "\n\n";

   confile << "Word           Number of";
   if(ctType=='s') confile << "   Stanza number\n";
   else if(ctType=='p' || ctType=='c') confile << "   Page number\n";
   else if(ctType=='l') confile << "   Line number\n";
   confile << "Len  Word:         uses:   Locations:\n";
   confile << wl;
}

void saveAlphabetFile(char *origFn, char *alphaFn,CharCtVector &ccv)
{
   ofstream alphafile(alphaFn);
   assert(alphafile!=0); //POSSIBLY CHANGE THIS FOR MOTIF TO ERROR MESSAGE BOX & RETURN TO LET OP REDO

   alphafile << ccv;
}

//out of memory message to display on screen in parser: UNUSED-FROM OLD PROGRAM.
void outOfMem(void)
{
 //CHANGE THIS FOR MOTIF TO ERROR MESSAGE BOX & RETURN TO LET OP REDO
   cerr << "\n\nERROR: You have insufficient memory to continue making a concorcance for this\n"
        << "document.  It will be necessary for you to shorten the document.  Break the document\n"
        << "into several pieces, and concatenate and sort the .wrd and .abc files that result from\n"
        << "making concordances for the several pieces.  Concordancing got to\n"
        << "pg/line number " << locNum << " in this document and " << fileLoc << " characters\n"
        << "had been read when the program had to exit due to lack of memory.\n";
   exit(1);
}
